/*
Stuff 2.0.

Checksum: 1666273838 (verify with "brik")

(C) Copyright 1989 Rahul Dhesi.  Permission is granted to copy and
distribute this file in modified or unmodified form, whether for
noncommercial or commercial use, provided (a) this copyright notice
is preserved, (b) no attempt is made to restrict redistribution of
this file, and (c) this file is not distributed as part of any
collection whose redistribution is restricted by a compilation
copyright.
*/

/* Gives help */
#include <stdio.h>
#include "stuff.h"

void givehelp (void)
{
printf (
"Stuff 2.0, a public domain file finder for use with zoo, by Rahul Dhesi\n"
"Usage:  stuff pathnames ... [ conditions ... ]\n\n"

"\"pathnames\" are filenames/directory names, MSDOS wildcards ok, files are\n"
"listed if they meet all conditions, ! reverses following condition.  If / is\n"
"in pattern then pathname must match, else only filename need match.  If more\n"
"than one filename is specified, all matching files are selected.  Conditions:\n\n"

"-name pattern    wildcards ok, * matches all files, dot is not special\n"
"-name @file      read patterns from file, one on each line\n"
"-size N          size is N kilobytes (+N means over N, -N means less than N)\n"
"-mtime N         modified N days ago (+N means over N, -N means less than N)\n"
"-modified        modified since last backup (tests \"archive\" bit)\n"
"-older filename  older than specified file (false if \"filename\" not found)\n"
"-newer filename  newer than specified file (true if \"filename\" not found)\n\n"

"To recursively list all files in /bin and /new whose names end in DOC or EXE,\n"
"and which are not listed in the file \"stoplist\", and which have been\n"
"modified in the last two days, and which are no more than 8 kilobytes long,\n"
"excluding all files in the /bin/scr subdirectory, the command is:\n\n"

"stuff /bin /new -name *.DOC -name *.EXE ! -name @stoplist -mtime -3\n"
"    ! -size +8 ! -name /bin/scr*\n"
);
}
